#!/usr/bin/env python3

import subprocess
import json

workspaces = json.loads(subprocess.run(["i3-msg", "-t", "get_workspaces"], stdout=subprocess.PIPE).stdout)
numbered_workspaces = [ws for ws in workspaces if ws['num'] != -1]
#focused = next(ws for ws in workspaces if ws['focused'] == True)
maximum_ws = max(numbered_workspaces, key=lambda ws: ws['num'])
# loop through all possible workspace numbers
for ws_num in range(1, maximum_ws['num']):
    # if workspace with current number doesn't exist
    # TODO: handle multiple missing workspaces (consecutive or not)
    if next((ws for ws in numbered_workspaces if ws['num'] == ws_num), None) is None:
        # loop through all greater numbers and move down 1
        for ws in [ws for ws in numbered_workspaces if ws['num'] > ws_num]:
            new_name = ws['name'].split(":")
            new_name[0] = str(int(new_name[0]) - 1) # subtract 1 from workspace number
            subprocess.run(["i3-msg", "rename", "workspace",
                            ws['name'], "to", ":".join(new_name)])
